<?php
/*
 * ==================================================================
 * Plugin GLOSSAIRE_XH for CMSimple_XH
 * ==================================================================
 * Version:    1.0.4 - aug 2016
 * Copyright:  Ludovic AMATHIEU
 * Website:    http://www.f5swn.fr (and contact)
 * License:    GNU GPLv3 - http://www.gnu.org/licenses/gpl-3.0.en.html
 * ==================================================================
 */

if (!defined('CMSIMPLE_XH_VERSION')) {
    header('HTTP/1.0 403 Forbidden');
    exit;
}

if (!defined("PATH_GLOSS_CONFIG")) define("PATH_GLOSS_CONFIG", $pth['folder']['plugins']."glossaire/config/");
if (!defined("PATH_GLOSS_DATA")) define("PATH_GLOSS_DATA", $pth['folder']['plugins']."glossaire/data/");
if (!defined("PATH_GLOSSAIRE")) define("PATH_GLOSSAIRE", $pth['folder']['plugins']."glossaire/");

$version = "\n<!-- Plugin GLOSSAIRE V ".GLOSS_VERSION." -->\n\n";

// Les fonctions suivantes complètent $lemot avant sont insertion dans la regex avec la prise en charge du pluriel
// Il est prévu une fonction par langue (pluriel_fr pour le français par exemple).

// Français
function pluriel_fr($var) {
        $search = array(
                '`(al)\b`',
                '`(?<![\(\|])(ail)\b`',
                '`(?<![\(\|])(eu)\b`',
				'`(?<![\(\|])(au)\b`',
				'`(?<![\(\|])(ou)\b`',
                '`(?<![\)sxz])\z`',
                );

        $replace = array(
                '($1|aux|aus|als)',
                '($1|aux|aus|ails)',
                '($1|eux|eus)',
                '($1|aux|aus)',
                '($1|oux|ous)',
                '(s)?',
                );

        $var = preg_replace ($search, $replace, $var, 1);
        return $var;
}

// Anglais
function pluriel_en($var) {
        $search = array(
                '`\z`',
                );

        $replace = array(
                '(s)?',
                );

        $var = preg_replace ($search, $replace, $var, 1);
        return $var;
}

// Italien
function pluriel_it($var) {
        $search = array(

                '`(llo)\b`',
                '`(?<![\(\|])(e)\b`',
                '`(?<![\(\|])(co)\b`',
                '`(?<![\(\|])(ca)\b`',
                '`(?<![\(\|])(go)\b`',
                '`(?<![\(\|])(ga)\b`',
                '`(?<![\(\|])(ia)\b`',
                '`(?<![\(\|])(o)\b`',
                '`(?<![\(\|])(a)\b`',
                );

        $replace = array(

                '($1|la)',
                '($1|oi)',
                '($1|ci|chi|che)',                
                '($1|chi|che)',
                '($1|gi|ghi|ghe)',                
                '($1|ghe)',
                '($1|e|ie)',
                '($1|ini|ei|a||i)',
                '($1|e)',
                );

        $var = preg_replace ($search, $replace, $var, 1);
        return $var;
}

// Danois
function pluriel_da($var) {
        $search = array(
                '`(at)\b`',
                '`(af)\b`',
                '`(en)\b`',
                '`(?<![\(\|\)])(æ)(t)(?![\(\|\)])\b`',
                '`(?<![\(\|\)])(er)(?![\(\|\)])\b`',
                '`(?<![\(\|\)])(o)(?![\(\|\)])\b`',
				'`(?<![\(\|\)])(o|a)(?![\(\|\)])`',
				'`(?<![\(\|\)])(æ)(?![\(\|\)])`',
				'`(?<![\(\|\)])(a|e|i|o|ø|u)(b|c|d|f|g|h|j|k|l|m|n|p|q|r|s|t|v|w|x|z)(?![\(\|\)])\b`',
                '`(?<![\(\|\)])(dom)(?![\(\|\)])\b`',
                '`(?<![\(\|\)])(e)(?![\(\|\)])\b`',
                '`(?<![\(\|\)])(s)(?![\(\|\)])\b`',
                '`(?<![\(\|\)])(er)(?![\(\|\)])\b`',
                '`(?<![\(\|\)])(a|i|o|u|æ|heb|ing|feb)(?![\(\|\)])\b`',
                '`(?<![?\(\|\)])\z`',
                );

        $replace = array(
                '($1|$1te|$1er|$1et|$1erne)',
                '($1|$1fe|$1fer)',
                '($1|e|ne|ner)',
				'($1$2|$1$2$2et|$1dder|$1dderne)',
				'($1|re)',
                '($1|øer)',
				'($1|ø|æ)',
                '($1|jø)',
                '($1$2|$1$2$2|$2$1r|$1$2t)(e|er|et|ne|ene|erne)?',
                '($1|$1e)',
                '($1|$1r|$1rne|$1t|n$1)',
                '($1|$1ene|$1e)',
                '($1|re|rer)',
                '($1|$1er)',
				'(e|er|et|ene|erne)?',
                );

        $var = preg_replace ($search, $replace, $var, 1);
        return $var;
}

// Allemand
function pluriel_de($var) {
        $search = array(
                '`(at|au|e|ent|and|ant|ist|or|ion|ik|heit|keit|shaft|tät|ung)\b`i',
                '`(in)\b`i',
                '`(ma|um|us)\b`i',
                '`(eur|ich|ier|ig|ling)\b`i',
				'`(to)\b`i',
                '`(?<![\(\|])(a)(?![\(\|])`i',         
                '`(?<![\(\|])(o)(?![\(\|])`i',         
                '`(?<![\(\|])(u)(?![\(\|])`i',         
                '`(?<![\)])\z`',          
                );

        $replace = array(
                '($1|$1e|$1n|$1en|$1er)',
                '($1|$1eu|$1nen|$1e)',
                '($1|men|uen)',
                '($1|$1e)',
				'($1|ten|tos)',
                '($1|ä)',
                '($1|ö)',
                '($1|ü)',
                '(s|n|en|nen|e|er|ern|se)?',
                );

        $var = preg_replace ($search, $replace, $var, 1);
        return $var;
}

// Russe
function pluriel_ru($var) {
		$search = array(
				'`(к|г|х|ш|щ|ж|ч)(а|о|у|э|ы|ь)?(?!\pL)`u',
                '`(?<![\(\|])(е)(?!\pL)(?![\(\|])`u',       
                '`(?<![\(\|])(o)(?!\pL)(?![\(\|])`u',
                '`(?<![\(\|])(a)(?!\pL)(?![\(\|])`u',
                '`(?<![\(\|])(я|ь|й)(?!\pL)(?![\(\|])`u',
                '`(?<![\)])\z`',        
                );

		$replace = array(
				'($1$2|$1и|$1а)',
                '($1|я)',
                '($1|а)',
                '($1|Ы|ы|и)',
                '($1|и)',
                '(Ы)?',
                );
        $var = preg_replace ($search, $replace, $var, 1);
        return $var;
}
// Traitement des pluriels y compris mots composés (dont les termes sont séparés par un espace ou tiret)
function pluriel($var, $pluriel) {
  $sep = ( strpos($var, ' ') !== false ) ? ' ' : (( strpos($var, '-') !== false ) ? '-' : '');
  if ($sep != '') {
  	$temp = explode ($sep, $var);
  	foreach ($temp as $value) {
  		$result[] = $pluriel($value);
  	}
  	$temp = implode ($sep, $result);
  	return $temp;
 	}
  else {
  	$var = $pluriel($var);
  	return $var;
 	}
}	

//strpos appliquée à une variable tableau
function strpos_arr($array_defs, $gpop_div) {
    foreach($array_defs as $what) {
        if(($pos = strpos($what, $gpop_div))!==false) return $pos;
    }
    return false;
} 

//source : http://www.weirdog.com/blog/php/trier-les-cles-accentuees-dun-tableau-associatif.html
function wd_unaccent_compare_ci($a, $b) {
    return strcmp(strtolower(OteAccents($a)), strtolower(OteAccents($b)));
}

//Langues
if ($sl != "" ) {
      $pl_lng = $sl;
}
else {$pl_lng = "en";}

$ctype = $pl_lng."_".strtoupper($pl_lng);
$char = strtoupper($charset);

setlocale(LC_CTYPE, '".$ctype.".".$char."'); //pour que le serveur accepte les caractères accentués dans le preg_replace plus bas.
                                         //nécessaire chez Free, par exemple.

 ///////////////////lecture de la liste de mots et stockage dans un tableau//////////////////////
$lefichier = "";
if (is_file(PATH_GLOSS_DATA.$sl."/wlist".INCEXT)) {         //si wlist.inc existe
   $fp = fopen (PATH_GLOSS_DATA.$sl."/wlist".INCEXT, "r");
   while (!feof($fp)) {
   $buffer = fgets ($fp, 4096);
   $lefichier .= $buffer;
   }
   fclose ($fp);

   if ($lefichier != ""){                      //si la liste n'est pas vide
      $lefichier = trim($lefichier);
      $lignes2 = explode(";", $lefichier);        //0|1;0|1 => [0|1] [0|1]

}
}
?>